<template>
  <div id="video-player">
    <a-scene embedded vr-mode-ui="enabled: false">
      <a-entity
        id="video-player-camera"
        fov="60"
        position="0 0 0"
        rotation="0 0 0"
        camera
        look-controls
      >
      </a-entity>
      <a-assets>
        <video
          id="video-player-video"
          :src="url"
          webkit-playsinline
          and
          playsinline
          crossOrigin="anonymous"
        ></video>
        <img
          id="video-player-image"
          :src="imageUrl"
          crossOrigin="anonymous"
          decoding="async"
          v-if="imageUrl"
        />
      </a-assets>
      <a-sphere
        wireframe="true"
        wireframe-linewidth="2"
        v-if="isWireframeEnable"
      >
      </a-sphere>
      <a-videosphere
        src="#video-player-video"
        rotation="0 -90 0"
      ></a-videosphere>
      <a-sky
        src="#video-player-image"
        rotation="0 -90 0"
        v-if="imageUrl"
      ></a-sky>
    </a-scene>

    <div id="video-player-header">
      <p id="video-title">{{ title }}</p>
      <md-button
        class="md-simple md-just-icon"
        @click="toggleWireframeEnable"
        v-if="isEditorEnable"
      >
        <md-icon id="video-player-icon">language</md-icon>
      </md-button>
    </div>

    <div id="video-player-control">
      <div id="video-player-time">00:00 / 00:00</div>
      <div id="video-player-play-button">
        <md-icon id="video-player-icon" v-if="isPausing">play_arrow</md-icon>
        <md-icon id="video-player-icon" v-else>pause</md-icon>
      </div>
      <div id="video-player-progressbar">
        <div
          id="video-player-seekbar"
          v-bind:style="{ background: '#' + color }"
        ></div>
      </div>
      <div id="video-player-cardboard-button">
        <svg style="width: 24px; height: 24px" viewBox="0 0 24 24">
          <path
            fill="#ffffff"
            d="M20.74,6H3.2C2.55,6 2,6.57 2,7.27V17.73C2,18.43 2.55,19 3.23,19H8C8.54,19 9,18.68 9.16,18.21L10.55,14.74C10.79,14.16 11.35,13.75 12,13.75C12.65,13.75 13.21,14.16 13.45,14.74L14.84,18.21C15.03,18.68 15.46,19 15.95,19H20.74C21.45,19 22,18.43 22,17.73V7.27C22,6.57 21.45,6 20.74,6M7.22,14.58C6,14.58 5,13.55 5,12.29C5,11 6,10 7.22,10C8.44,10 9.43,11 9.43,12.29C9.43,13.55 8.44,14.58 7.22,14.58M16.78,14.58C15.56,14.58 14.57,13.55 14.57,12.29C14.57,11.03 15.56,10 16.78,10C18,10 19,11.03 19,12.29C19,13.55 18,14.58 16.78,14.58Z"
          />
        </svg>
      </div>
      <div id="video-player-fullscreen-button">
        <md-icon id="video-player-icon">fullscreen</md-icon>
      </div>
      <div class="clear"></div>
    </div>

    <div id="video-modal" v-if="isShowModal" v-on:click="isShowModal = false">
      <div id="video-modal-background"></div>
      <div id="video-modal-content">
        <p class="tb-text-right">
          <md-icon id="video-player-icon" style="color: black !important"
            >close</md-icon
          >
        </p>
        <p>お使いのブラウザでは、この機能はご利用いただけません。</p>
        <p>This feature is not available in your browser.</p>
      </div>
    </div>
  </div>
</template>

<script>
import 'aframe';
import 'aframe-look-at-component';
import JQuery from 'jquery';
let $ = JQuery;

const isFullscreenSupport = () => {
  // ブラウザがフルスクリーンモードに対応しているときtrueを返す
  var ua = window.navigator.userAgent;
  if (ua.indexOf('Macintosh;') > 0 && ua.indexOf('Safari') > 0) {
    return true;
  }

  var version = ua.match(/iPad; CPU OS ([\d]+)_([\d]+)/);
  if (version && Number(version[1]) >= 12) {
    // TODO: iPad OS 12.0 以上も非対応にする
    return false;
  }
  if (ua.indexOf('Safari') != -1 && ua.indexOf('Chrome') == -1) {
    return false;
  }

  return (
    document.fullscreenEnabled ||
    document.document.mozFullScreenElement ||
    document.webkitFullscreenEnabled ||
    document.msFullscreenElement
  );
};

const isFullscreenMode = () => {
  // ブラウザがフルスクリーンモードに移行しているときtrueを返す
  if (document.webkitFullscreenElement) return document.webkitFullscreenElement;
  else if (document.mozFullScreenElement) return document.mozFullScreenElement;
  else if (document.msFullscreenElement) return document.msFullscreenElement;
  else if (document.fullscreenElement) return document.fullscreenElement;
  else return false;
};

const changeToFullscreen = () => {
  // スクリーンモードに移行する
  var player = $('#video-player').get(0);
  if (document.fullscreenEnabled) player.requestFullscreen();
  else if (document.webkitFullscreenEnabled) player.webkitRequestFullscreen();
  else if (document.mozFullScreenEnabled) player.mozRequestFullScreen();
  else if (document.msFullscreenEnabled) player.msRequestFullscreen();
  else return;
};

const changeToFullscreenExit = () => {
  // フルスクリーンモードを解除する
  if (document.webkitFullscreenEnabled) document.webkitCancelFullScreen();
  else if (document.mozFullScreenEnabled) document.mozCancelFullScreen();
  else if (document.msFullscreenEnabled) document.msExitFullscreen();
  else if (document.fullscreenEnabled) document.exitFullscreen();
  else return;
};

const toHms = (t) => {
  // 秒をHH:MM:SS形式に変換する
  t = Math.round(t);

  var e = (t) => {
    if (t < 10) {
      return '0' + t;
    }
    return t;
  };

  var n = (t / 3600) | 0;
  var i = ((t % 3600) / 60) | 0;
  var r = t % 60;

  if (n != 0) {
    return e(n) + ':' + e(i) + ':' + e(r);
  }

  if (i != 0) {
    return e(i) + ':' + e(r);
  }

  return '00:' + e(r);
};

const buttonColor = (index) => {
  // ボタンのカラーを決定する
  var colors = new Array(
    '#2976b1',
    '#fc802d',
    '#34a03a',
    '#d3282f',
    '#9366b9',
    '#8a564d',
    '#e177bf',
    '#7f7f7f',
    '#bbbd3e',
    '#2ebecd'
  );
  return colors[index % colors.length];
};

// ボタンの初期の大きさ
const SIZE_WIDTH = 4.0;
const SIZE_HEIGHT = 3.0;

export default {
  name: 'vr-video-player',
  props: {
    url: {
      type: String,
      default: '',
    },
    imageUrl: {
      type: String,
      default: null,
    },
    isEditorEnable: {
      type: Boolean,
      default: false,
    },
    isKeyEventEnable: {
      type: Boolean,
      default: false,
    },
    buttons: {
      type: Array,
      default: null,
    },
    movableButton: {
      type: Object,
      default: null,
    },
    videoHeight: {
      type: Number,
      default: 400,
    },
    title: {
      type: String,
      default: '',
    },
    color: {
      type: String,
      default: '2962FF',
    },
    centerX: {
      type: Number,
      default: 0,
    },
    centerY: {
      type: Number,
      default: 0,
    },
    isWireframeEnableProp: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      timer: null,
      isPausing: true,
      isShowModal: false,
      isWireframeEnable: false,
    };
  },
  beforeDestroy() {
    clearInterval(this.timer);
  },
  watch: {
    movableButton: function (value) {
      this.createMovableButton();
    },
    buttons: function (value) {
      this.createButtons();
    },
    videoHeight: function (value) {
      $('#video-player').height(value);
    },
    centerX: function (value) {
      var camera = $('#video-player-camera').get('0');
      var x = this.centerX * -1;
      var y = this.centerY;
      AFRAME.utils.entity.setComponentProperty(
        camera,
        'rotation',
        `${y} ${x} 0`
      );
    },
    centerY: function (value) {
      var camera = $('#video-player-camera').get('0');
      var x = this.centerX * -1;
      var y = this.centerY;
      AFRAME.utils.entity.setComponentProperty(
        camera,
        'rotation',
        `${y} ${x} 0`
      );
    },
  },
  mounted() {
    this.timer = setInterval(() => {
      this.countProgress();
    }, 1000);
    var camera = $('#video-player-camera').get('0');
    var video = $('#video-player-video').get('0');
    var image = $('#video-player-image').get('0');
    var scene = $('a-scene');
    var videoSphere = $('a-videosphere')[0];
    var isSeeking = false;

    this.isWireframeEnable = this.isWireframeEnableProp;

    if (this.isEditorEnable) {
      camera.removeAttribute('look-controls');
      AFRAME.utils.entity.setComponentProperty(
        camera,
        'rotation',
        `0 ${this.centerX * -1} 0`
      );
    }

    // プレイヤーの高さを決める
    $('#video-player').height(this.videoHeight);

    scene.mouseenter((e) => {
      $('#video-player-control').animate({ opacity: 1.0 }, 400);
    });

    scene.mouseleave((e) => {
      if (!this.isWireframeEnable) {
        $('#video-player-control').animate({ opacity: 0.0 }, 400);
      }
    });

    $('#video-player-control').mouseover((e) => {
      $('#video-player-control').animate({ opacity: 1.0 }, 400);
    });

    $('#video-player-fullscreen-button').bind('mousedown', (e) => {
      // フルスクリーンボタンを押したとき
      if (isFullscreenSupport() == false) {
        this.isShowModal = true;
        return;
      }

      if (isFullscreenMode()) {
        changeToFullscreenExit();
      } else {
        changeToFullscreen();
      }
    });

    $('#video-player-progressbar').bind('mousedown', (e) => {
      var x = e.offsetX;
      if (e.type == 'touchstart') {
        x = e.originalEvent.changedTouches[0].offsetX;
      }

      isSeeking = true;
      $('#video-player-seekbar').width(x);

      $('#video-player-progressbar').bind('mousemove', (e) => {
        $('#video-player-seekbar').width(e.offsetX);
      });

      $('#video-player-progressbar').bind('mouseup', (e) => {
        $('#video-player-progressbar').unbind('mousemove mouseup');

        var x = e.offsetX;
        var d = video.duration;
        var w = $('#video-player-progressbar').width();
        var c = (d / w) * x;

        $('#video-player-seekbar').width(x);
        video.currentTime = c;
        isSeeking = false;
      });
    });

    $('#video-player-play-button').click((e) => {
      if (video.paused) {
        video.play();
      } else {
        video.pause();
      }

      this.isPausing = !this.isPausing;
    });

    document.addEventListener('keydown', (e) => {
      if (!this.isKeyEventEnable) {
        // キーイベントが無効のとき
        return;
      }

      if (e.code != 'Space') {
        return;
      }

      if (video.paused) {
        video.play();
      } else {
        video.pause();
      }

      this.isPausing = !this.isPausing;
    });

    video.addEventListener('ended', (e) => {
      // 最後まで再生したとき
      $('#video-player-seekbar').width(0);
      video.paused();
      this.isPausing = true;
    });

    $('#video-player-cardboard-button').click((e) => {
      // カードボードボタンを押したとき
      if (isFullscreenSupport() == false) {
        this.isShowModal = true;
        return;
      }

      video.play();
      this.isPausing = false;

      scene = document.querySelector('a-scene');
      scene.enterVR();
    });

    this.createMovableButton();
    this.createButtons();
  },
  methods: {
    // GURUVR-6586: adjust progress-bar every seconds
    countProgress() {
      var video = $('#video-player-video').get('0');
      var d = video.duration;
      var c = video.currentTime;
      var w = $('#video-player-progressbar').width();

      var time = toHms(c) + ' / ' + toHms(d);
      if (this.isEditorEnable) {
        time += ' (' + Math.round(c) + ' / ' + Math.round(d) + ')';
      }
      $('#video-player-seekbar').width((w * c) / d);
      $('#video-player-time').html(time);
      $('a-sky').remove();
    },
    toggleWireframeEnable: function (e) {
      this.isWireframeEnable = !this.isWireframeEnable;

      if (this.isWireframeEnable) {
        $('#video-player-control').css(
          'background-color',
          'rgba(0, 0, 0, 0.5)'
        );
      } else {
        $('#video-player-control').css('background-color', '');
      }
    },
    createMovableButton: function (e) {
      // ボタンを削除する
      $('#vr-video-player-movable-button').remove();

      if (this.movableButton === null) {
        return;
      }

      var color = buttonColor(0);
      var marker = document.createElement('a-plane');
      $('a-scene').append(marker);

      var xValue = this.movableButton.position_x;
      var yValue = this.movableButton.position_y;
      var hValue = this.movableButton.size_height * SIZE_HEIGHT;
      var wValue = this.movableButton.size_width * SIZE_WIDTH;

      var radX = THREE.Math.degToRad(xValue - 90);
      var radY = THREE.Math.degToRad(-1 * yValue + 90);
      var r = 10;

      var x = Math.cos(radX) * Math.sin(radY) * r;
      var z = Math.sin(radX) * Math.sin(radY) * r;
      var y = Math.cos(radY) * r;

      AFRAME.utils.entity.setComponentProperty(
        marker,
        'id',
        'vr-video-player-movable-button'
      );
      AFRAME.utils.entity.setComponentProperty(
        marker,
        'position',
        `${x} ${y} ${z}`
      );
      AFRAME.utils.entity.setComponentProperty(marker, 'color', color);
      AFRAME.utils.entity.setComponentProperty(marker, 'opacity', '0.7');
      AFRAME.utils.entity.setComponentProperty(marker, 'height', hValue);
      AFRAME.utils.entity.setComponentProperty(marker, 'width', wValue);
      AFRAME.utils.entity.setComponentProperty(marker, 'look-at', '[camera]');
    },
    createButtons: function (e) {
      // ボタンを削除する

      $('.vr-video-player-button').remove();

      if (this.buttons === null) {
        return;
      }

      this.buttons.forEach((button, index) => {
        var xValue = button.position_x;
        var yValue = button.position_y;
        var hValue =
          button.size_height == null
            ? SIZE_HEIGHT
            : button.size_height * SIZE_HEIGHT;
        var wValue =
          button.size_width == null
            ? SIZE_WIDTH
            : button.size_width * SIZE_WIDTH;

        var color = buttonColor(index);
        var marker = document.createElement('a-plane');
        $('a-scene').append(marker);

        var radX = THREE.Math.degToRad(xValue - 90);
        var radY = THREE.Math.degToRad(-1 * yValue + 90);
        var r = 10;

        var x = Math.cos(radX) * Math.sin(radY) * r;
        var z = Math.sin(radX) * Math.sin(radY) * r;
        var y = Math.cos(radY) * r;

        AFRAME.utils.entity.setComponentProperty(
          marker,
          'class',
          `vr-video-player-button`
        );
        AFRAME.utils.entity.setComponentProperty(
          marker,
          'id',
          `vr-video-player-button-${index}`
        );
        AFRAME.utils.entity.setComponentProperty(
          marker,
          'position',
          `${x} ${y} ${z}`
        );
        AFRAME.utils.entity.setComponentProperty(marker, 'color', color);
        AFRAME.utils.entity.setComponentProperty(marker, 'opacity', '0.7');
        AFRAME.utils.entity.setComponentProperty(marker, 'width', wValue);
        AFRAME.utils.entity.setComponentProperty(marker, 'height', hValue);
        AFRAME.utils.entity.setComponentProperty(marker, 'look-at', '[camera]');
      });
    },
  },
};
</script>

<style scoped>
a-scene {
  display: block;
  position: relative;
  height: 100%;
  width: 100%;
}
#video-player {
  position: relative;
  background: #000000;
}
#video-player:-webkit-full-screen {
  height: 100%;
  width: 100%;
}
#video-player-header {
  position: absolute;
  top: 0;
  color: white;
}
#video-player-control {
  position: absolute;
  color: white;
  bottom: 0px;
  height: 60px;
  font-size: 20px;
  width: 100%;
  background: rgba(0,0,0,0.8);
}
#video-player-play-button {
  cursor: pointer;
  float: left;
  width: 10%;
  height: 40px;
  text-align: center;
}
#video-player-cardboard-button {
  cursor: pointer;
  float: left;
  width: 10%;
  height: 40px;
  text-align: center;
}
#video-player-fullscreen-button {
  cursor: pointer;
  float: left;
  width: 10%;
  height: 40px;
  text-align: center;
}
#video-player-progressbar {
  float: left;
  background: #ffffff;
  height: 10px;
  width: 70%;
  cursor: pointer;
  margin: 10px 0;
}
#video-player-seekbar {
  background: #2962ff;
  height: 10px;
  width: 0px;
}
#video-player-time {
  font-size: 12px;
  text-align: right;
  padding: 0 20px;
  color: #ffffff !important;
}
#video-player-icon {
  color: #ffffff !important;
}
#video-title {
  margin: 20px 10px 0 10px;
  font-weight: bold;
}
#video-modal {
  height: 100vh;
  position: fixed;
  top: 0;
  width: 100%;
}
#video-modal-background {
  background: rgba(0, 0, 0, 0.8);
  height: 100vh;
  position: absolute;
  width: 100%;
}
#video-modal-content {
  background: #fff;
  left: 50%;
  padding: 20px 40px;
  position: absolute;
  top: 50%;
  transform: translate(-50%, -50%);
  width: 60%;
}
</style>
